-- hide the big ugly frame border 
local function HideBorder(frame)
	frame.borderFrame:Hide()
end
hooksecurefunc("CompactRaidGroup_UpdateBorder",  HideBorder)
 
-- change raid frame and nameplate healthbar textures
hooksecurefunc("CompactUnitFrame_UpdateAll",  function(frame)
	if not frame:IsForbidden()  then
		frame.healthBar:SetStatusBarTexture("Interface\\BUTTONS\\WHITE8X8")
	end
end)

-- /run SetCVar("predictedHealth", 1)


--##############
local default_roles = {"MAINTANK","MAINASSIST","TANK","DAMAGER","HEALER"}
local default_class = {"WARRIOR", "ROGUE", "PALADIN", "DEATHKNIGHT", "MONK","DEMONHUNTER","SHAMAN","DRUID","HUNTER","MAGE","WARLOCK","PRIEST", "EVOKER"}
local incombatlockdown = "In combat lockdown."
 
 
local handler = CreateFrame("Button", nil, UIParent, "SecureHandlerBaseTemplate" )

local container_dummy = CreateFrame("Frame", nil, CompactRaidFrameContainer , "SecureFrameTemplate")
container_dummy:SetPoint("TOPLEFT", CompactRaidFrameContainer, "TOPLEFT")
container_dummy:SetSize(10,10)
CompactRaidFrameContainerBorderFrame:SetParent(container_dummy)
handler:SetFrameRef("container_dummy", container_dummy)

local container_party = CreateFrame("Frame", nil, PartyFrame , "SecureFrameTemplate")
container_party:SetPoint("TOPLEFT", CompactPartyFrame, "TOPLEFT", 2, 0)
container_party:SetSize(10,10)
handler:SetFrameRef("container_party", container_party)

handler:SetFrameRef("EditModeManagerFrame", EditModeManagerFrame)


handler:Execute([[
	roles = newtable()
	class = newtable()
	
	CompactRaidFrameN = 0
	CompactPartyFrame = nil

 	container_buttons = newtable()
	CompactRaidGroups = newtable()
	
	wtable = newtable()
	childs = newtable()
	orpheline = newtable()
	ownedunit = newtable()
	unit2roles = newtable()
	unit2class = newtable()	
	
]])

handler:Execute([==[ 
update = [[
	if self:GetAttribute("frameref-EditModeManagerFrame"):IsShown() then
		return
	end
	
	local container_dummy = self:GetAttribute("frameref-container_dummy")
	local container = container_dummy:GetParent()
	wipe(childs)
	container:GetChildList(childs)

	for i=1, #childs do
		local frame = childs[i]
		if frame ~= container_dummy and not CompactRaidGroups[frame] then   
			local name = frame:GetName()
			if name then
				if name:sub(1, 16) == "CompactRaidFrame" then
					n = tonumber(name:sub(17, #name))
					if n > CompactRaidFrameN then
						CompactRaidFrameN=n
						tinsert(container_buttons, frame)
					end
				elseif name:sub(1, 16) == "CompactRaidGroup" then
					CompactRaidGroups[frame] = 1
				end
			end
		end
	end	
	
    local container_party = self:GetAttribute("frameref-container_party")
	if not CompactPartyFrame then
		wipe(childs)
		container_party:GetParent():GetChildList(childs)
		for i=1, #childs do
			local frame = childs[i]
			local name = frame:GetName()
			if name and name == "CompactPartyFrame" then
				CompactPartyFrame = frame				
				wipe(wtable)
				frame:GetChildList(wtable)
				for _, button in next, wtable do
					local n = button:GetName()
					if n and n:sub(18,23) == "Member" then
					tinsert(container_buttons, button)
					end
				end
			end
		end	
	end
	
	
	local FrameFilterOptions = self:GetAttribute("frameref-FrameFilterOptions")
	local seeContainer = container:IsShown() 
	local playerinraid = (PlayerInGroup() == "raid")
	local CompactParty = CompactPartyFrame and CompactPartyFrame:IsShown()

	if playerinraid and seeContainer == true then
		FrameFilterOptions:Show(true)
	else 
		FrameFilterOptions:Hide(true)
	end

	for frame in next, CompactRaidGroups do
		if frame:IsVisible() then
			return
		end
	end
	
	if not seeContainer and not CompactParty then
		return
	end

	wipe(orpheline)
	wipe(childs)
	for i=1, #container_buttons do
		local button = container_buttons[i]
		if button:IsVisible() then
			button:ClearAllPoints()
			local unit = button:GetAttribute("unit")
			if unit then
				childs[button] = unit
			else
				tinsert(orpheline, button)
			end
		end
	end

	local Xoffset = next(childs) or orpheline[1]

	if not Xoffset then
		return
	end

	wipe(unit2roles)
	wipe(unit2class)
	
	local groupheader = self:GetAttribute("frameref-groupheader")
	for i=1, #roles do
		local role = roles[i]
		groupheader:SetAttribute("roleFilter", role)
		for j=1, 120  do
			local button = groupheader:GetAttribute("frameref-child"..j)
			if button then
				local unit = button:GetAttribute('unit')
				if unit then
					if ( not unit2roles[unit] or role == "MAINTANK" or role == "MAINASSIST" ) then 
						unit2roles[unit] = i
					end
				else
					break
				end
			else
				break
			end
		end
	end

	groupheader:Hide(true) -- ignore attributechanged
	groupheader:SetAttribute("roleFilter", nil)
	groupheader:Show(true)
	for i=1, #class do
		groupheader:SetAttribute("groupFilter", class[i])
		for j=1, 120  do
			local button = groupheader:GetAttribute("frameref-child"..j)
			if button then
				local unit = button:GetAttribute('unit')
				if unit then 
					unit2class[unit] = i
				else
					break
				end
			else
				break
			end
		end
	end

	local unit_p 
	if CompactParty and playerinraid then   -- arena 
		groupheader:SetAttribute("groupFilter", nil)
		local shift = groupheader:GetAttribute("frameref-child1"):GetAttribute('unit')
		if player_position then unit_p=shift
		end
		shift = tonumber(shift:sub(5,5))
		for i =1, 4 do
			local party = "party"..i
			local raid 
			if i < shift then
				raid = "raid"..i
			else
				raid = "raid"..(i+1)
			end
			unit2roles[party] = unit2roles[raid]
			unit2class[party] = unit2class[raid]
		end
	elseif player_position then
		groupheader:SetAttribute("groupFilter", nil)
		unit_p = groupheader:GetAttribute("frameref-child1"):GetAttribute('unit')
	else
		groupheader:Hide(true)		
		groupheader:SetAttribute("groupFilter", nil)
		groupheader:Show(true)
	end

	wipe(wtable)
	wipe(ownedunit)
	
	for button, unit in next, childs do
 		if unit_p == unit then
			tinsert(orpheline, 1, button)
		else
			local class = unit2class[unit]
			local role = unit2roles[unit]
			if class and role  then
				local i = 0
				repeat
					i = i+1
					local b = wtable[i]
					if not b then break end
					local u = childs[b]
				until role < unit2roles[u] or (role == unit2roles[u] and  class  <= unit2class[u]) 
				tinsert(wtable, i, button)
				
			else 	
				local n = #unit
				if unit:sub(n-5, n) == "target" then
					ownedunit[button] = ((unit:sub(n-11, n-6) == "target") and unit:sub(1, n-12)) or unit:sub(1, n-6)
				elseif pet_below then
					if unit == "pet" then
						ownedunit[button] = "player"
					else
						local a, b = unit:find("pet")
						if a then
							ownedunit[button] = unit:sub(1, a-1)..unit:sub(b+1)
						else	
							tinsert(orpheline, button)
						end
					end
				else
					tinsert(orpheline, button)
				end
			end
		end
	end
	
	if unit_p then
		for i=1, #orpheline do
			local button = orpheline[i]
			if childs[button] == unit_p then
				if player_position > 0 and player_position <= #wtable then
					tinsert(wtable, player_position, button)
				else
					tinsert(wtable, button)
				end
				orpheline[i] = nil
			else
				break
			end
		end
	end

	for _, button in next, orpheline do
		tinsert(wtable, button)
	end
 
 	local Yoffset 
	local H
	local anchor
	if seeContainer then
		H = 1+ container:GetHeight()/ Xoffset:GetScale()
		Yoffset = 0
		anchor = container_dummy
	else
		H = 1+ CompactPartyFrame:GetHeight()/ Xoffset:GetScale()
		Yoffset = 14
		anchor = container_party
	end

	local x = 0
	local y = Yoffset
	Xoffset = Xoffset:GetWidth() 
 
	for i=1, #wtable do
		local button = wtable[i]
		local unit = childs[button]
		if i < 7 then
			self:GetAttribute("frameref-XTarget"..i):SetAttribute("unit", unit)
		end
		local h = button:GetHeight()
		
 		if  y+h> H then
			x = x+Xoffset
			y = Yoffset
		end
		button:SetPoint("TOPLEFT", anchor, "TOPLEFT", x, -y)
		y = y+h
		
		for b, u in next, ownedunit do
			if u == unit then
				b:SetPoint("TOPLEFT", anchor,"TOPLEFT", x, -y)
				y = y+b:GetHeight()
				ownedunit[b] = nil
			end
		end
	end

	for button in next, ownedunit do
		local h = button:GetHeight()
 		if  y+h > H then
			x = x+Xoffset
			y = Yoffset
		end
		button:SetPoint("TOPLEFT", anchor, "TOPLEFT", x, -y)
		y = y+h
	end
]]
]==])

local frame = CreateFrame("Frame", nil, nil, "SecureGroupHeaderTemplate")
frame:SetScript("OnShow", nil)
frame:UnregisterEvent("GROUP_ROSTER_UPDATE")
frame:UnregisterEvent("UNIT_NAME_UPDATE")
frame:SetAttribute("template", "SecureFrameTemplate")
 
frame:SetAttribute("nameList", UnitName("player")) -- default update
frame:SetAttribute("showRaid", true)
frame:SetAttribute("showParty", true)
frame:SetAttribute("showPlayer", true)
handler:SetFrameRef("groupheader", frame)
frame:Show()

local petheader = CreateFrame("Frame", nil, nil, "SecureGroupPetHeaderTemplate")
petheader:SetScript("OnAttributeChanged", nil)
petheader:SetAttribute("template", "SecureFrameTemplate")
petheader:Show()
local petheaderchild1 = petheader:GetAttribute("child1")
handler:SetFrameRef("petheaderchild1", petheaderchild1)
petheader:SetParent(CompactRaidFrameManager)
RegisterAttributeDriver(petheaderchild1, "unit", 1)
handler:WrapScript(petheaderchild1, "OnAttributeChanged", [[if value then owner:Run(update) end]])

local function UpdateHandler()
	petheaderchild1:SetAttribute("unit", nil)
end
handler:WrapScript(container_dummy, "OnShow", [[owner:GetAttribute("frameref-petheaderchild1"):SetAttribute("unit", nil)]])
 
for i=1, 6 do
	local button = CreateFrame("Button", "XTarget"..i, WorldFrame, "SecureActionButtonTemplate")
	handler:SetFrameRef("XTarget"..i, button)
	button:SetAttribute("type", "target")	
	button:RegisterForClicks("LeftButtonDown")
end


-- BLIZZARD MANAGER 
local function ToggleManager()
	if CompactRaidFrameManager.collapsed == true or RaidFramesPlus.hide then
		RaidFramesPlusManager1:Hide()
	else
		RaidFramesPlusManager1:Show()
	end

end

hooksecurefunc("CompactRaidFrameManager_Toggle", ToggleManager)
CompactRaidFrameManagerToggleButton:HookScript("OnMouseDown", function(self, button) 
	if button and button == "RightButton" then
		RaidFramesPlus.hide = not RaidFramesPlus.hide
	end
	ToggleManager()
end)


local options = {
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterRoleTank,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterRoleHealer,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterRoleDamager,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup1,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup2,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup3,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup4,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup5,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup6,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup7,
	CompactRaidFrameManagerDisplayFrameFilterOptionsFilterGroup8,
}
 
options[3]:SetHitRectInsets(0,4, 0,0)

local function highlight_show(self)
	if self:GetAttribute("clickbutton"):IsEnabled() == true then
		self:GetHighlightTexture():Show()
	else
		self:GetHighlightTexture():Hide()
	end
end
	
local anchor
local parent = CompactRaidFrameManager
for i=1, #options  do
	local button = options[i]
	local dummy = CreateFrame("Button", nil, parent, "SecureActionButtonTemplate")
	
	dummy:RegisterForClicks("LeftButtonDown")
	dummy:SetSize(button:GetSize())
	dummy:SetScript("OnEnter", highlight_show)
	dummy:SetHighlightTexture(button:GetHighlightTexture())
	--dummy:SetNormalTexture("Interface\\BUTTONS\\WHITE8X8")
	--dummy:SetAlpha(0.5)

	if i == 1 then
		--<Size x="58" y="24"/>
		handler:SetFrameRef("FrameFilterOptions", dummy)
		parent = dummy
		dummy:SetPoint("TOPLEFT", CompactRaidFrameManager, "TOPLEFT", 9, -25)
  	elseif i <4 then
 		dummy:SetPoint("LEFT", anchor, "RIGHT")
		if i == 3 then
			dummy:SetWidth(button:GetWidth()-4)
		end
	elseif i == 4 then
		--<Size x="41" y="24"/>
		dummy:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", -2*58, 0)
 	elseif i < 8 then
		dummy:SetPoint("LEFT", anchor, "RIGHT", 2, 0)
	elseif i == 8 then
		dummy:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", -3*(41+2), 0)
	else
		dummy:SetPoint("LEFT", anchor, "RIGHT", 2, 0)
	end
	anchor = dummy
	
	dummy:SetAttribute("type", "click")
	dummy:SetAttribute("clickbutton", button)
 end
anchor = nil
parent = nil


-- MY MANAGER

local fs = RaidFramesPlusManager1:CreateFontString(nil, "OVERLAY")
fs:SetPoint("TOP", RaidFramesPlusManager1, "TOP", -2, -10)
fs:SetFontObject("GameFontHighLightLeft")
fs:SetText("Sorting 'combined groups'\nand party")

local dropdownframe = CreateFrame("Button", nil, RaidFramesPlusManager1, "DialogBorderDarkTemplate")
local button_player = CreateFrame("Button",nil, RaidFramesPlusManager1, "UIDropDownMenuTemplate")

--button_player.Button:SetScript("OnMouseDown", nil)
button_player.Button:SetScript("OnMouseDown", function()
	PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	if dropdownframe:IsShown() then
		dropdownframe:Hide()
	else
		dropdownframe:Show()
	end
end)

button_player:ClearAllPoints()
button_player:SetPoint("TOPRIGHT", 2, -37)
UIDropDownMenu_SetWidth(button_player, 74);

local fs = button_player:CreateFontString(nil, "OVERLAY")
fs:SetFontObject("GameFontNormalSmallLeft")
fs:SetPoint("RIGHT", button_player, "LEFT", 10, 0)
fs:SetText("Player position")
 
local function load_player(player_position)
	for i =1, 8 do 
		local button = dropdownframe["Button"..i]
		if player_position ~= button.value then
			button.Check:Hide()
			button.UnCheck:Show()
		else
			button.Check:Show()
			button.UnCheck:Hide()
		end
	end
	
	button_player.Text:SetText(dropdownframe["Button"..player_position]:GetText())
	if player_position == 1 then
		handler:Execute("player_position = nil")
	else
		handler:Execute("player_position = "..(player_position-2))
	end
end 
 
local function SimpleUIDropDownMenuButton_OnClick(self)
	if InCombatLockdown() then print(incombatlockdown) return end
	self:GetParent():Hide()
	PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON);
	local value = self.value
	RaidFramesPlus.player_position = value
	load_player(value)
	UpdateHandler()
end

dropdownframe:Hide()
dropdownframe:ClearAllPoints()
dropdownframe:SetSize(100,158)
dropdownframe:SetFrameStrata("DIALOG")
dropdownframe:SetPoint("TOP", button_player, "BOTTOM", 0, 6)
for i =1, 8 do 
	local button = CreateFrame("Button", nil, dropdownframe,  "SimpleUIDropDownMenuButtonTemplate")
	
	dropdownframe["Button"..i] = button
	button.value = i
	button:SetPoint("TOP", dropdownframe, "TOP", 0, -(i-1)*16-15)
	button:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	button:SetScript("OnClick", SimpleUIDropDownMenuButton_OnClick)
	
	local text
	if i == 1 then
		text = "None"
	elseif i == 2 then
		text = "Bottom"
	else
		text = i-2
	end
	button:SetText(text)
end
 
local macro = CreateFrame("Button", nil, RaidFramesPlusManager1, "UIMenuButtonStretchTemplate")
macro:SetWidth(172)
macro:SetHeight(20)
macro:SetPoint("TOP", button_player, "BOTTOM", -42, -5)
macro:SetText("Create Target Macro")
  
macro:SetScript("OnClick", function()
	if InCombatLockdown() then print(incombatlockdown) return end
	local name = "RaidFramesPlus"
	local index = GetMacroIndexByName(name)
	if index == 0 then 
		if MacroFrame then MacroFrame.selectedMacro = nil end
		
		index =  CreateMacro(name, "Inv_pet_egbert", [[#You can also use the bindings interface, tab 'Add-ons'
#Change 1 by the desired position (max 6)
/click ]].."XTarget1 LeftButton true") 
		print("Macro |cff00F0F0RaidFramesPlus|r created.")
	else
		print("Macro |cff00F0F0RaidFramesPlus|r already exists.")
	end
	if index then
		ShowMacroFrame()
		--MacroFrameTab1:Click()
		--MacroFrame:SelectMacro(index)
	else
		Print("Macro full ?")
	end
end)

local button_order_roles = CreateFrame("Button",nil, RaidFramesPlusManager1, "UIMenuButtonStretchTemplate")

local function order_text(self)
	if InCombatLockdown() then print(incombatlockdown) return end
	local text 
	local opts
	if self == button_order_roles then
		opts = RaidFramesPlus.roles or default_roles
		text = 	[[/run Roles_order("]]
	else
		opts = RaidFramesPlus.class or default_class
		text = 	[[/run Class_order("]]
	end
	for i=1, #opts  do
		text = text..opts[i]..", "
	end
	text=text:sub(1,text:len()-2)
	text=text..[[")]]
	ChatFrame1EditBox:SetText(text)
	ChatFrame1EditBox:SetFocus() 
end

button_order_roles:SetWidth(86)
button_order_roles:SetHeight(20)
button_order_roles:SetPoint("TOPLEFT", macro, "BOTTOMLEFT", 0,-2)
button_order_roles:SetText("Roles order")
button_order_roles:SetScript("OnClick", order_text)

local button_order_class = CreateFrame("Button", nil, RaidFramesPlusManager1, "UIMenuButtonStretchTemplate")
button_order_class:SetWidth(86)
button_order_class:SetHeight(20)
button_order_class:SetPoint("TOPRIGHT", macro, "BOTTOMRIGHT", 0, -2)
button_order_class:SetText("Class order")
button_order_class:SetScript("OnClick", order_text)
 
local function load_orders(t, kind)
	for i=1, #t  do
		  handler:Execute(kind..'['..i.."]='"..t[i].."'") 
	end
end

local function tableINtable(t1, t2)
	for _, v in ipairs(t1) do
		if not tContains(t2, v) then
			return nil
		end
	end
	return 1
end
 
function Roles_order(msg)
	if InCombatLockdown() then print(incombatlockdown) return end
	local t = {msg:match("[^%a]*(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]*")}
	if not next(t) then
		print("|cffFF0000Error - wrong pattern or role(s) missing.|r")
	else
		if tableINtable(t, default_roles) and tableINtable(default_roles, t) then
			RaidFramesPlus.roles = t
			load_orders(t, "roles")
			UpdateHandler()
			print("Success - new role order saved :", unpack(t))
		
		else
		
			print("|cffFF0000Error - role(s) mistyped or multiple.|r")
		end
	end	
end

function Class_order(msg)
	if InCombatLockdown() then print(incombatlockdown) return end
	local t = {msg:match("[^%a]*(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]+(%a+)[^%a]*")}
	if not next(t) then
		print("|cffFF0000Error - wrong pattern or class missing.|r")
	else
		if tableINtable(t, default_class) and tableINtable(default_class, t) then
			RaidFramesPlus.class = t
			load_orders(t, "class")
			UpdateHandler()

			print("Success - new class order saved :", unpack(t))
			
		else
		
			print("|cffFF0000Error - class mistyped or multiple.|r")
		end
	end	
end

local button_petbelow = CreateFrame("CheckButton", nil, RaidFramesPlusManager1, "UICheckButtonTemplate")
local function load_petlow(pet_below)
	handler:Execute("pet_below = "..tostring(pet_below))
	button_petbelow:SetChecked(pet_below)
end

button_petbelow:SetSize(24,24)
button_petbelow:SetHitRectInsets(0,-130, 0,0)
button_petbelow.text:SetText("Anchor pets under owner");
button_petbelow:SetScript("OnClick", function(self)
	if InCombatLockdown() then print(incombatlockdown) return end
	local value = self:GetChecked()
	RaidFramesPlus.pet_below = value
	load_petlow(value)
	UpdateHandler()
end)
button_petbelow:SetPoint("BOTTOMLEFT",   10, 10)

local function GetProfile()
	if CompactPartyFrame:IsShown() then
		return 1
	elseif CompactRaidFrameContainer:IsShown() then
		return 2
	else
		return nil
	end
end
 
-- AURA SIZE SLIDER
local aura_size = CreateFrame("Slider", nil, RaidFramesPlusManager2, "UISliderTemplate")
aura_size:SetHitRectInsets(0,0, 3,3)
aura_size:SetPoint("TOP", RaidFramesPlusManager2, "TOP", 0, -20)
aura_size:SetMinMaxValues(0, 20)

local fs = aura_size:CreateFontString(nil, "OVERLAY")
fs:SetFontObject("GameFontHighLightSmallLeft")
fs:SetPoint("BOTTOMLEFT", aura_size, "TOPLEFT", 40, 0)
aura_size:SetSize(144,17)
aura_size.text = fs

local baseSize
local function update_debuffs(frame)
	if baseSize and frame.debuffFrames and frame.maxDebuffs > 0 then
		for i=1, #frame.debuffFrames do
			local aura = frame.debuffFrames[i]
			aura:SetSize(baseSize,baseSize)
		end		
	end
end

local function update_buffs(frame)
	if baseSize and frame.buffFrames and frame.maxBuffs > 0 then
		for i=1, #frame.buffFrames do
			local aura = frame.buffFrames[i]
			aura:SetSize(baseSize,baseSize)
		end		
	end
end

hooksecurefunc("CompactUnitFrame_UpdateAuras", update_debuffs)

local function update_baseSize(value)
 	local frameHeight  = EditModeManagerFrame:GetRaidFrameHeight(CompactPartyFrame:IsShown())
	
	local options = DefaultCompactUnitFrameSetupOptions
	local powerBarHeight = 8
 	local powerBarUsedHeight = options.displayPowerBar and powerBarHeight or 0
	local componentScale = (frameHeight-4-powerBarUsedHeight)/30  

 	baseSize = (value+10)*componentScale
	CompactRaidFrameContainer:ApplyToFrames("normal", update_debuffs)
	CompactRaidFrameContainer:ApplyToFrames("normal", update_buffs)
end

local function update_aura_size(value)
	if value == 0 then
		baseSize = nil
		aura_size.text:SetText("Aura size : ignore")
	else
		update_baseSize(value)
		aura_size.text:SetText("Aura size : "..value)
	end
end

aura_size:SetValue(0)
aura_size:SetScript("OnValueChanged", function(self,value)
	value = floor(value)
	
	local profile = GetProfile()
	if not profile then
		return
	end
	if value ~= RaidFramesPlus[profile].aura then
		RaidFramesPlus[profile].aura = value
		update_aura_size(value)
	end
end)





 -- HIDE ROLE AND NAME

local button_name =  CreateFrame("CheckButton", nil, RaidFramesPlusManager2, "UICheckButtonTemplate")
local button_role =  CreateFrame("CheckButton", nil, RaidFramesPlusManager2, "UICheckButtonTemplate")
button_role:SetSize(24,24)
button_role:SetPoint("BOTTOMLEFT", 10,10)
button_role.text:SetText("Hide role")
button_role:SetHitRectInsets(0,-45, 0,0)
button_name:SetSize(24,24)
button_name:SetHitRectInsets(0,-50, 0,0)
button_name:SetPoint("LEFT", button_role, "RIGHT", 62, 0)
button_name.text:SetText("Hide name")

local function toggle_name(frame)
	if frame:IsForbidden() or not frame:GetName() then
		return
	end
	local profile = GetProfile()
	if not profile then
		return
	end
	local name = frame.name
	if name then 
		if RaidFramesPlus[profile].hide_name then
			name:Hide() 
		else
			name:Show() 
		end
	end
end

local function toggle_role(frame)

	if frame:IsForbidden() or not frame:GetName() then
		return
	end
	local profile = GetProfile()
	if not profile then
		return
	end
	local roleIcon = frame.roleIcon
	if roleIcon then	
		if RaidFramesPlus[profile].hide_role then
			roleIcon:Hide() 
		else
			roleIcon:Show() 
		end
	end
end

button_role:SetScript("OnClick", function(self)
	local profile = GetProfile()
	if not profile then
		return
	end
	RaidFramesPlus[profile].hide_role = self:GetChecked()
	CompactRaidFrameContainer:ApplyToFrames( "normal", toggle_role)
end)
 
button_name:SetScript("OnClick", function(self)
	local profile = GetProfile()
	if not profile then
		return
	end
	RaidFramesPlus[profile].hide_name = self:GetChecked()
	CompactRaidFrameContainer:ApplyToFrames("normal", toggle_name)
	CompactRaidFrameContainer:ApplyToFrames("mini", toggle_name)
end)
hooksecurefunc("CompactUnitFrame_UpdateName", toggle_name)
hooksecurefunc("CompactUnitFrame_UpdateRoleIcon", toggle_role)


-- LOAD STUFF



local function ApplyProfile()
	local profile = GetProfile()
	if profile then
		button_name:SetChecked(RaidFramesPlus[profile].hide_name)
		button_role:SetChecked(RaidFramesPlus[profile].hide_role)
		
		local value = RaidFramesPlus[profile].aura or 0
		aura_size:SetValue(value)
		update_aura_size(value)
	else
		update_aura_size(0)
	end
 end


CompactPartyFrame:HookScript("onHide", ApplyProfile)
CompactPartyFrame:HookScript("OnShow", ApplyProfile)
CompactRaidFrameContainer:HookScript("onHide", ApplyProfile)
CompactRaidFrameContainer:HookScript("OnShow", ApplyProfile)

RaidFramesPlusManager1:RegisterEvent("PLAYER_ENTERING_WORLD")
RaidFramesPlusManager1:RegisterEvent("PLAYER_LOGIN")
RaidFramesPlusManager1:RegisterEvent("PLAYER_LOGOUT")

RaidFramesPlusManager1:SetScript("OnEvent", function(_, event)
	if event == "PLAYER_LOGIN" then
		SetCVar("showPartyBackground", nil)
		SetCVar("showArenaEnemyPets", nil) -- showArenaEnemyFrames  showArenaEnemyCastbar
		RaidFramesPlus = RaidFramesPlus or {}
		load_orders(RaidFramesPlus.class or default_class, "class")
		load_orders(RaidFramesPlus.roles or default_roles, "roles")
		load_player(RaidFramesPlus.player_position or 1)
		load_petlow(RaidFramesPlus.pet_below)	

		RaidFramesPlus[1] = RaidFramesPlus[1] or {}
		RaidFramesPlus[2] = RaidFramesPlus[2] or {}
		ApplyProfile()
		--handler:Execute("showPartyPets ="..tostring(GetCVar("showPartyPets") == '1' ) )
		--update_showPartyPets(showPartyPets)
	elseif event == "PLAYER_ENTERING_WORLD" then
		ToggleManager()
	elseif event == "PLAYER_LOGOUT" then
		--SetCVar("showPartyPets", GetManagedEnvironment(handler).showPartyPets)
	end
end)
  


-- MISC

CompactRaidFrameManagerBg:SetDrawLayer("BACKGROUND")
CompactRaidFrameManagerToggleButton:SetFrameLevel(3)

local update = [[
	local child = owner:GetAttribute("frameref-petheaderchild1") 
	if child:GetParent():IsVisible() then
		child:SetAttribute("unit", nil)
	end
]]

handler:WrapScript(CreateFrame("Frame", nil, SettingsPanel, "SecureFrameTemplate"), "OnHide",update)
handler:WrapScript(CreateFrame("Frame", nil, EditModeManagerFrame.CloseButton, "SecureFrameTemplate"), "OnHide",update)
EditModeManagerFrame.CloseButton:HookScript("OnHide", ApplyProfile)
SettingsPanel:HookScript("OnHide", ApplyProfile)

hooksecurefunc("CompactUnitFrame_SetUpFrame", function(frame)
	if frame:IsForbidden() or not frame:GetName() then
	return
	end
	if frame.background then
	frame.background:SetIgnoreParentAlpha(false)
	end
	frame:RegisterForClicks("AnyDown")
	if frame.debuffFrames and frame.maxDebuffs > 0 then
		for i=1, #frame.debuffFrames do
			local aura = frame.debuffFrames[i]
 			aura:EnableMouse(false)
 
		end
	end
	if frame.buffFrames and frame.maxBuffs > 0 then
		for i=1, #frame.buffFrames do
			local aura = frame.buffFrames[i]
			aura.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
			aura:EnableMouse(false)
			if baseSize then
 			aura:SetSize(baseSize,baseSize)
			end
		end
	end
end)
